Attribute VB_Name = "Main"
Option Explicit

Public Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Public Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long
Public Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Public Declare Function RegSetValue Lib "advapi32.dll" Alias "RegSetValueA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Public Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

Const ERROR_SUCCESS = 0&
Const ERROR_BADDB = 1&
Const ERROR_BADKEY = 2&
Const ERROR_CANTOPEN = 3&
Const ERROR_CANTREAD = 4&
Const ERROR_CANTWRITE = 5&
Const ERROR_OUTOFMEMORY = 6&
Const ERROR_INVALID_PARAMETER = 7&
Const ERROR_ACCESS_DENIED = 8&

Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
Public Const HKEY_PERFORMANCE_DATA = &H80000004
Public Const HKEY_CURRENT_CONFIG = &H80000005
Public Const HKEY_DYN_DATA = &H80000006
Public Const REG_SZ = 1                         ' Unicode nul terminated string
Public Const REG_BINARY = 3                     ' Free form binary
Public Const REG_DWORD = 4                      ' 32-bit number
Private Const MAX_PATH = 260&

Declare Function GetShortPathName Lib "kernel32" _
      Alias "GetShortPathNameA" (ByVal lpszLongPath As String, _
      ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
      
Declare Function GetFullPathName Lib "kernel32" Alias "GetFullPathNameA" (ByVal lpFileName As String, ByVal nBufferLength As Long, ByVal lpBuffer As String, ByVal lpFilePart As String) As Long


Const OFS_MAXPATHNAME = 128
Const OF_CREATE = &H1000
Const OF_READ = &H0
Const OF_WRITE = &H1
Private Type OFSTRUCT
        cBytes As Byte
        fFixedDisk As Byte
        nErrCode As Integer
        Reserved1 As Integer
        Reserved2 As Integer
        szPathName(OFS_MAXPATHNAME) As Byte
End Type

Public Declare Function CopyFile Lib "kernel32" Alias "CopyFileA" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String, ByVal bFailIfExists As Long) As Long


Public Function GetSettingString(hKey As Long, strPath As String, strValue As String, Optional Default As String) As String
Dim hCurKey As Long
Dim lValueType As Long
Dim strBuffer As String
Dim lDataBufferSize As Long
Dim intZeroPos As Integer
Dim lRegResult As Long

' Set up default value
If Not IsEmpty(Default) Then
  GetSettingString = Default
Else
  GetSettingString = ""
End If

' Open the key and get length of string
lRegResult = RegOpenKey(hKey, strPath, hCurKey)
lRegResult = RegQueryValueEx(hCurKey, strValue, 0&, lValueType, ByVal 0&, lDataBufferSize)

If lRegResult = ERROR_SUCCESS Then

  If lValueType = REG_SZ Then
    ' initialise string buffer and retrieve string
    strBuffer = String(lDataBufferSize, " ")
    lRegResult = RegQueryValueEx(hCurKey, strValue, 0&, 0&, ByVal strBuffer, lDataBufferSize)
    
    ' format string
    intZeroPos = InStr(strBuffer, Chr$(0))
    If intZeroPos > 0 Then
      GetSettingString = Left$(strBuffer, intZeroPos - 1)
    Else
      GetSettingString = strBuffer
    End If

  End If

Else
  ' there is a problem
End If

lRegResult = RegCloseKey(hCurKey)
End Function

Public Sub SaveSettingString(hKey As Long, strPath As String, strValue As String, strData As String)
Dim hCurKey As Long
Dim lRegResult As Long

lRegResult = RegCreateKey(hKey, strPath, hCurKey)

lRegResult = RegSetValueEx(hCurKey, strValue, 0, REG_SZ, ByVal strData, Len(strData))

If lRegResult <> ERROR_SUCCESS Then
  'there is a problem
End If

lRegResult = RegCloseKey(hCurKey)
End Sub

Function CreateContextMenu() As Boolean

On Error GoTo ErrSub
Dim Path As String
Dim Ret&
Dim lphKey&

Path = App.Path
If Right(Path, 1) <> "\" Then Path = Path & "\"

Ret& = RegCreateKey&(HKEY_CLASSES_ROOT, "*\shell\Wipper", lphKey&)
If Ret& <> ERROR_SUCCESS Then Exit Function

Ret& = RegSetValue&(HKEY_CLASSES_ROOT, ".mq4", REG_SZ, "EMC.File", MAX_PATH)
If Ret& <> ERROR_SUCCESS Then Exit Function

Ret& = RegCreateKey&(HKEY_CLASSES_ROOT, "*\shell\Wipper\command", lphKey&)
If Ret& <> ERROR_SUCCESS Then Exit Function

Ret& = RegSetValue&(lphKey&, "", REG_SZ, Path & App.EXEName & ".exe" & " %1", MAX_PATH)
If Ret& <> ERROR_SUCCESS Then Exit Function

Ret& = RegCreateKey&(HKEY_CLASSES_ROOT, "Folder\shell\Wipper\command", lphKey&)
If Ret& <> ERROR_SUCCESS Then Exit Function

Ret& = RegSetValue&(lphKey&, "", REG_SZ, Path & App.EXEName & ".exe" & " %1", MAX_PATH)
If Ret& <> ERROR_SUCCESS Then Exit Function

CreateContextMenu = True
Exit Function

ErrSub:

End Function

Function DeleteContextMenu() As Boolean

On Error GoTo ErrSub
Dim Ret&

Ret& = RegDeleteKey&(HKEY_CLASSES_ROOT, "*\shell\Wipper\command")
If Ret& <> ERROR_SUCCESS Then Exit Function

Ret& = RegDeleteKey&(HKEY_CLASSES_ROOT, "*\shell\Wipper")
If Ret& <> ERROR_SUCCESS Then Exit Function

Ret& = RegDeleteKey&(HKEY_CLASSES_ROOT, "Folder\shell\Wipper\command")
If Ret& <> ERROR_SUCCESS Then Exit Function

DeleteContextMenu = True
Exit Function

ErrSub:

End Function

Function IfFileExists(ByVal sFilename As String) As Boolean
Dim I As Long
On Error Resume Next
I = Len(Dir$(sFilename))
If Err Or I = 0 Then
    IfFileExists = False
Else
    IfFileExists = True
End If
End Function

Function GetFileName(ByVal sPath As String) As String
'    Dim I As Integer
'    On Error Resume Next
'    sPath = Replace(sPath, Chr(34), "", , , vbTextCompare)
'    I = InStrRev(sPath, "\", , vbTextCompare)
'    If (I > -1) Then
'        GetFileName = Mid(sPath, I + 1, Len(sPath) - I)
'    End If
On Error Resume Next
Dim d As String
d = Dir(sPath, vbNormal)
GetFileName = d
End Function

Function GetDirectoryName(ByVal sPath As String) As String
    Dim I As Integer
    On Error Resume Next
     sPath = Replace(sPath, Chr(34), "", , , vbTextCompare)
    I = InStrRev(sPath, "\", , vbTextCompare)
    If (I > -1) Then
        GetDirectoryName = Mid(sPath, 1, I - 1)
    End If
End Function
Public Function GetShortName(ByVal sLongFileName As String) As String
    Dim lRetVal As Long, sShortPathName As String, iLen As Integer
    On Error Resume Next
    sShortPathName = Space(255)
    iLen = Len(sShortPathName)
    lRetVal = GetShortPathName(sLongFileName, sShortPathName, iLen)
    GetShortName = Left(sShortPathName, lRetVal)
End Function

Public Function GetLongtName(ByVal sLongFileName As String) As String
    Dim Buffer As String, Ret As Long
    'create a buffer
    Buffer = Space(255)
    'copy the current directory to the buffer and append 'myfile.ext'
    Ret = GetFullPathName(sLongFileName, 255, Buffer, "")
    'remove the unnecessary chr$(0)'s
    Buffer = Left(Buffer, Ret)
    'show the result
    GetLongtName = Buffer

End Function
Public Function APIFileCopy(src As String, dest As String, _
  Optional FailIfDestExists As Boolean) As Boolean

    Dim lRet As Long
    On Error Resume Next
    lRet = CopyFile(src, dest, FailIfDestExists)
    APIFileCopy = (lRet > 0)
End Function

Public Function RemoveQuotations(src As String) As String
    RemoveQuotations = Replace(src, Chr(34), "", , , vbTextCompare)
End Function
Public Sub OutputToFile(fname As String, Instructions As String)
Dim hOut As Integer

hOut = FreeFile

Open fname For Output Access Write Lock Read Write As hOut
    Print #hOut, Instructions
Close hOut

End Sub
